#
# Copyright © 2020 MSC.Software Corporation
#  
# Permission to use Scripts
#  
# Permission is granted to MSC.Software customers with valid licenses of the MSC Apex™ software 
# to use script files posted on this page (collectively “Scripts”) solely for customers’ own authorized 
# internal use in conjunction with licensed use of the MSC Apex software.  
# No other use is permitted.  No license to MSC Apex or other software is granted under this Permission.
#  
# SCRIPTS ARE PROVIDED ON AN "AS-IS" BASIS, WITH NO WARRANTIES OF ANY KIND.  USE OF THE SCRIPTS IS AT CUSTOMER'S SOLE RISK.
#  
# IN NO EVENT SHALL MSC.SOFTWARE CORPORATION, ITS AFFILIATES, SUBSIDIARIES, SUPPLIERS, AGENTS, REPRESENTATIVES OR EMPLOYEES BE LIABLE FOR ANY 
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, TORT, 
# STRICT LIABILITY, OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION USE OF THE SCRIPTS, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
#  
# Customer shall indemnify, defend and hold MSC.Software Corporation, its affiliates, subsidiaries, suppliers, agents, 
# employees or representatives (collectively, “Indemnified Parties”) harmless from and against any third-party claims 
# brought against Indemnified Parties rising out of or in connection with Customer’s use of the Scripts.
#
import sys
import os
import apex_sdk
import clr

#.NET references
import System
import System.Windows.Controls as WPFControls
from System.Windows.Automation import AutomationProperties
from Microsoft.Win32 import OpenFileDialog


def getUIContent():

	my_toolProperty = apex_sdk.ToolPropertyContainer()
	my_toolProperty.ToolPropertyContent = getCustomToolPropertyContent()

	my_toolProperty.TitleText = "Assign Sections properties for Hypersizer Export"
	
	file_path = os.path.dirname(os.path.realpath(__file__))
	my_toolProperty.TitleImageUriString = os.path.dirname(file_path) + "\\res\\AutoAssignSections.png"
	
	
	my_toolProperty.WorkFlowInstructions = """<HTML><BODY><P STYLE=\"font-size:10;\"><SPAN>Auto Assign Thickness on Selected Faces.<br>
	New section will try to obtain section data from existing section information. If not assigned, defalts will be used. <br>
	Non uniform thicknes and/or offset is not allowed</SPAN></P>
	<P><SPAN> </SPAN></P>
	<P STYLE=\"font-size:10;\"><SPAN>Send questions and comments to Stefan Tynelius@hexagon.com.  Elvis sightings as usual are sent to larry.pearce@hexagon.com</SPAN></P></BODY></HTML>"""

	#define pickFiterTools
	my_toolProperty.ShowPickChoice = True
	my_toolProperty.IsCustomTool   = True
	#setPickFilterTools()
	my_toolProperty.PickFilterList = setPickFilterTools()


	#handle apply button (green) click event
	my_toolProperty.AppliedCommand = apex_sdk.ActionCommand(System.Action(HandleApplyButton))
	# handle exit button (red) click event
	my_toolProperty.ExitCommand = apex_sdk.ActionCommand(System.Action(HandleExitButton))
	
	return my_toolProperty






#get tool property content
def getCustomToolPropertyContent():
	#Create a Grid
	my_Grid = WPFControls.Grid()
	
	createLayout(my_Grid, 5, 2)

	row = 0
	col = 0
	
	
	#global deleteOverhangComboBox
	#deleteOverhangComboBox = createComboBox(my_Grid, "Delete Overhang:", ["Yes", "No"], 0, row, col)
	
	#areaAdjust_Toggle  = createCheckBox2(my_Grid, "Geom/FE Area Adjustment", row, col)
	
	
	#row += 1
	
	#deleteOverhangComboBox.SelectionChanged += deleteOverhangComboBoxCB
	
	global SectionNamePrefixDataBox, SectionNamePrefixTextBlock
	SectionNamePrefixDataBox, SectionNamePrefixTextBlock = createDataBox(my_Grid, "Section Prefix: ", "Section_", row, col)
	row += 1
	
	global SectionStartIdDataBox, SectionStartIdTextBlock
	SectionStartIdDataBox, SectionStartIdTextBlock = createDataBox(my_Grid, "Start Id: ", "101", row, col)
	row += 1
	
	global DefaultThicknessDataBox, DefaultThicknessTextBlock
	DefaultThicknessDataBox, DefaultThicknessTextBlock = createDataBox(my_Grid, "Default Thickness: ", "1.0", row, col)
	row += 1
	
	global DefaultOffsetDataBox, DefaultOffsetTextBlock
	DefaultOffsetDataBox, DefaultOffsetTextBlock = createDataBox(my_Grid, "Default Offset: ", "0.0", row, col)
	row += 1
	
	
	
	#global fileTextBox
	#fileTextBox = createDataBox2(my_Grid, "", row, col)
	#row += 1
	
	# WPFControls.Grid.SetColumnSpan(fileTextBox, 2)
	
	# importBtn = WPFControls.Button()
	# importBtn.Content="Select file with instances to delete"
	
	# WPFControls.Grid.SetColumnSpan(importBtn, 2)
	
	# WPFControls.Grid.SetRow(importBtn, row)
	# WPFControls.Grid.SetColumn(importBtn, col)
	
	# #Link a function to the Button "Click" event 
	# #This function will be called every time the Button is clicked
	# importBtn.Click+=HandleimportBtn
	
	# # Add the controls to the Grid
	# my_Grid.Children.Add(importBtn)
	
	#Return the Grid
	return my_Grid
	

def deleteOverhangComboBoxCB(sender, event):
	# I need to learn and understand sender and event
	#global deleteOverhangComboBox
	#global diaTextBlock, diaTextBox
	global SectionNamePrefixDataBox
	#global stiffnessComboTextBlock, stiffnessCombBox
	
	choices = deleteOverhangComboBox.SelectedValue.ToString().split(":")
	choice = choices[len(choices)-1].lstrip().rstrip()
	
	SectionNamePrefixDataBox.Visibility       = System.Windows.Visibility.Visible
	SectionNamePrefixTextBlock.Visibility     = System.Windows.Visibility.Visible



def createLayout(parent, numRows, numCols):
	for k in range(numRows):
		parent.RowDefinitions.Add(WPFControls.RowDefinition())
	for k in range(numCols):
		parent.ColumnDefinitions.Add(WPFControls.ColumnDefinition())


def createComboBox(parent, title, labels, selected, row, col):
	textBlock = WPFControls.TextBlock()
	textBlock.Text = title
	WPFControls.Grid.SetRow(textBlock, row)
	WPFControls.Grid.SetColumn(textBlock, col)

	parent.Children.Add(textBlock)
	
	comboBox = WPFControls.ComboBox()
	for label in labels:
		item = WPFControls.ComboBoxItem()
		item.Content=label
		comboBox.Items.Add(item)
	
	WPFControls.Grid.SetRow(comboBox, row)
	WPFControls.Grid.SetColumn(comboBox, col+1)
	
	if selected > len(labels): selected = 0
	comboBox.SelectedIndex=str(selected)
	
	parent.Children.Add(comboBox)
	
	return comboBox

def createCheckBox2(parent, label, row, col):

	checkBox = WPFControls.CheckBox()
	checkBox.Content = label
	WPFControls.Grid.SetRow(checkBox, row)
	WPFControls.Grid.SetColumn(checkBox, col)
	
	parent.Children.Add(checkBox)
	
	return checkBox




def createDataBox(parent, title, value, row, col):
	textBlock = WPFControls.TextBlock()
	textBlock.Text = title
	WPFControls.Grid.SetRow(textBlock, row)
	WPFControls.Grid.SetColumn(textBlock, col)

	textBox =WPFControls.TextBox()
	WPFControls.Grid.SetRow(textBox, row)
	WPFControls.Grid.SetColumn(textBox, col+1)
	textBox.Text=value
	
	parent.Children.Add(textBlock)
	parent.Children.Add(textBox)
	
	return textBox, textBlock

def createDataBox2(parent, value, row, col):
	textBox =WPFControls.TextBox()
	WPFControls.Grid.SetRow(textBox, row)
	WPFControls.Grid.SetColumn(textBox, col)
	textBox.Text=value
	
	parent.Children.Add(textBox)
	
	return textBox

#set pickFilers
#some pick choices are commented out
def setPickFilterTools():
	pickChoices = System.Collections.Generic.List[System.String]()
	
	#exclusive picking and visibility picking	
	pickChoices.Add(apex_sdk.PickFilterTypes.ExclusivePicking)
	pickChoices.Add(apex_sdk.PickFilterTypes.VisibilityPicking)
	
	#Assembly and part
	#pickChoices.Add(apex_sdk.PickFilterTypes.Assembly)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Part)
	
	#Bodies	
	#pickChoices.Add(apex_sdk.PickFilterTypes.SolidMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Solid)
	#pickChoices.Add(apex_sdk.PickFilterTypes.SurfaceMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Surface)
	#pickChoices.Add(apex_sdk.PickFilterTypes.CurveMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Curve)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Point)
	
	#features
	#pickChoices.Add(apex_sdk.PickFilterTypes.CellMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.FaceMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.EdgeMesh)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Cell)
	#pickChoices.Add(apex_sdk.PickFilterTypes.VertexMesh)
	
	#Lower Dimensional Entities
	#pickChoices.Add(apex_sdk.PickFilterTypes.Element3D)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Element2D)
	pickChoices.Add(apex_sdk.PickFilterTypes.Face)
	#pickChoices.Add(apex_sdk.PickFilterTypes.MeshSeed)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Element1D)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Edge)
	#pickChoices.Add(apex_sdk.PickFilterTypes.SeedPoint)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Node)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Vertex)
	
	#Sub Lower Dimensional Entities
	#pickChoices.Add(apex_sdk.PickFilterTypes.ElementEdge)
	#pickChoices.Add(apex_sdk.PickFilterTypes.ElementFace)
	
	#Interactions and connections
	#pickChoices.Add(apex_sdk.PickFilterTypes.DiscreteTie)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Connector)
	#pickChoices.Add(apex_sdk.PickFilterTypes.EdgeTie)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Joint)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Glue)
	
	#LBCs
	#pickChoices.Add(apex_sdk.PickFilterTypes.Pressure)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Gravity)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Constraint)
	#pickChoices.Add(apex_sdk.PickFilterTypes.ForceMoment)
	#pickChoices.Add(apex_sdk.PickFilterTypes.EnforcedMotion)
	
	#Attributes and other objects
	#pickChoices.Add(apex_sdk.PickFilterTypes.CompositeZone)
	#pickChoices.Add(apex_sdk.PickFilterTypes.LayeredPanel)
	#pickChoices.Add(apex_sdk.PickFilterTypes.InterfacePoint)
	#pickChoices.Add(apex_sdk.PickFilterTypes.PointMass)
	#pickChoices.Add(apex_sdk.PickFilterTypes.BeamSpan)
	#pickChoices.Add(apex_sdk.PickFilterTypes.Offset)
	
	#Sensors
	#pickChoices.Add(apex_sdk.PickFilterTypes.MotionEnvelopeSensor)
	#pickChoices.Add(apex_sdk.PickFilterTypes.ClearanceSensor)
	#pickChoices.Add(apex_sdk.PickFilterTypes.CrossSectionSensor)
	#pickChoices.Add(apex_sdk.PickFilterTypes.PointSensor)
	
	#Coordinate system
	#pickChoices.Add(apex_sdk.PickFilterTypes.CoordinateSystem)
	
	#Tool Registration
	#Tool Name has to be the same
	#apex_sdk.PickFilterRegistration.RegisterTool("Auto Tie Nodes", pickChoices)
	return pickChoices


#Function to handle the Import Button "Click" event
#This function gets called every time the Button is clicked
@apex_sdk.errorhandler
def HandleimportBtn(sender,args):

	#Create a File open dialog
	dialog = OpenFileDialog()
	
	#Configure for single file selection
	dialog.Multiselect = False
	
	#Set up the file types you want to support
	dialog.Filter = "All Files  |*.*"
	#dialog.Filter = "Parasolid Files | *.X_T | All Files  |*.*"

	#Display the dialog
	#If it returns anything
	#   get the file name
	#   display it on the text nox 
	if dialog.ShowDialog():
		selectedFile = dialog.FileName
		fileTextBox.Text = selectedFile
		

@apex_sdk.errorhandler
def HandleApplyButton():
	file_path = os.path.dirname(os.path.realpath(__file__))
	script_path= os.path.join(file_path, 'AutoAssignSections.py')
	# Create a Dictionary to store the user defined tool data  
	dictionary = {}
	
	dictionary["Prefix"] = SectionNamePrefixDataBox.Text
	dictionary["StartId"] = SectionStartIdDataBox.Text
	dictionary["DefaultThickness"] = DefaultThicknessDataBox.Text
	dictionary["DefaultOffset"] = DefaultOffsetDataBox.Text	
	
	apex_sdk.runScriptFunction(script_path, "main", dictionary)
	
	
	
	
	
# exit button (red) from tool header
@apex_sdk.errorhandler
def HandleExitButton():
	print("HandleExitButton")

